<%@page import="javax.sql.rowset.spi.XmlWriter"%><%@ include
	file="includes/jspheader.jsp"%>
<%@ include file="includes/jspencoding.jsp"%>

<%@ include file="includes/logincheck.jsp"%>
<%@ include file="includes/returnurl.jsp"%>

<%@ page import="com.esko.webcenter.jsp.*"%>
<%@ page import="com.esko.webcenter.search.*"%>
<%@ page import="com.esko.webcenter.src.search.IndexConstants"%>
<%@ page import="com.esko.webcenter.src.util.*"%>
<%@ page import="com.esko.webcenter.src.root.view.ProjectView"%>
<%@ page import="com.esko.webcenter.src.root.view.UserView"%>
<%@ page import="com.esko.webcenter.src.root.view.ProjectWcTaskView"%>
<%@ page import="com.esko.webcenter.src.root.ComplexApprovalTM"%>
<%@ page
	import="com.esko.webcenter.src.root.view.ProjectWcTaskDocVersionView"%>
<%@ page import="com.esko.webcenter.src.xml.ProjectViewListXml"%>
<%@ page import="com.esko.webcenter.src.xml.ProjectWcTaskViewXml"%>
<%@ page
	import="com.esko.webcenter.src.xml.ProjectWcTaskDocVersionViewXml"%>
<%@ page import="com.esko.webcenter.cache.DocTypeCache"%>
<%@ page import="com.esko.webcenter.bom.*"%>

<%@ page import="java.util.Hashtable"%>
<%@ page import="java.util.Vector"%>
<%@ page import="java.util.Map"%>
<%@ page import="java.util.HashMap"%>
<%@ page import="java.io.IOException"%>

<%
	response.setHeader("Cache-Control", "no-cache"); //HTTP 1.1
	response.setHeader("Pragma", "no-cache"); //HTTP 1.0
	response.setDateHeader("Expires", 0); //prevents caching at the proxy server
%>
<%
	try {
		// do NOT clean up the tempfiles from the last request
		//	TempFileMgr.getTempFileMgr(session).deleteAllTempFiles();

		String searchName = request.getParameter("searchName");
		boolean showGridBool = false;
		boolean isShowThumbnails = ThumbnailMgr.isShowThumbnail(request, session);
		boolean searchReRun = SearchUtils.isSearchReRun(request);

		String projectID = request.getParameter("projectID"); // project ID parameter used in projet details
		String menuFile = request.getParameter("menu_file"); // menu file overwrite
		String projectName = null;

		boolean debug = "1".equals(request.getParameter("debug"));
		
		ProjDetailsPageHelper projDetailsPageHelper = null;
		if (projectID != null) {
			String pageTitle = searchName !=null ? searchName : "Project Search Results";
			projDetailsPageHelper = new ProjDetailsPageHelper(session, application, request, response, out, "projdetailsprojsearchresults", "Project Details - " + pageTitle);
			if (!projDetailsPageHelper.initialize())
				return;
			projectName = projDetailsPageHelper.getWcProject().getName();
		}
				

		SearchConfiguration.SEARCHTYPE searchType = SearchConfiguration.SEARCHTYPE.PROJECTSEARCH;
		String savedSearchType = null;

		String actionName = request.getParameter("action");

		if (searchName == null) {
			JSPUtils.showError(response, "Saved search name not specified");
			return;
		}

		// create the saved search ejb
		SavedSearchTM savedSearchTM = DBTMUtils.findBean(response, session, SavedSearchTM.class);
		if (savedSearchTM == null)
			return; // redirect already done; we can exit

		//try loading a GLOBAL saved search with the same name from the DB
		SavedSearch savedSearch = null;
		try {
			//try loading a personal SS with the same name from the DB
			savedSearch = savedSearchTM.findGlobalSavedSearchByName(LoginMgr.getLoginMgr(session).getLoginID(),
					searchName);
			if (savedSearch == null) {
				JSPUtils.showError(response, "Global saved search not found: " + searchName);
				return;
			}
			savedSearchType = savedSearch.getType();
			if (savedSearchType.equalsIgnoreCase("project_search")) {
				searchType = SearchConfiguration.SEARCHTYPE.PROJECTSEARCH;
			} else if (savedSearchType.equalsIgnoreCase("wctask_search")) {
				searchType = SearchConfiguration.SEARCHTYPE.TASKSEARCH;
			} else // one of many types of document search
			{
				searchType = SearchConfiguration.SEARCHTYPE.DOCUMENTSEARCH;
			}
		} catch (WebCenterRemoteException ejbEx) {
			DBTMUtils.processRemoteException(response, session, ejbEx,
					"SavedSearchTM.findGlobalSavedSearchByName");
			return;
		}

		String luceneCriteria = null;
		String extendedProjectLuceneCriteria = null;
		String extendedProjectUserCriteria = null;
		String updatedUserCriteria = null;
		String searchFormat = null;
		boolean isSavedSearchWithParms = (projectID != null) ? true : SearchUtils.hasSavedSearchCriteria(savedSearch.getXmlCriteria());
		
		String hpSectionId = request.getParameter("sectionID");
		if (hpSectionId == null)
			hpSectionId = "";

		String pageName; // name of the XSL to be used
		
		if (searchType == SearchConfiguration.SEARCHTYPE.PROJECTSEARCH) {
			pageName = projectID != null ? "projdetailsprojsearchresults" : "projsearchresults";
			searchFormat = "proj";
			showGridBool = SearchDisplayMgr.isShowProjectGrid(request, session);
			ProjectSearchActionPage projectSearchAction = new ProjectSearchActionPage(session, application,
					request, response);

			// Check for a session variable
			checkSessionVariable(session, savedSearch, projectSearchAction.getCriteriaVariableName() + hpSectionId, searchName);

			// required for old style saved searches.
			savedSearch.setXmlCriteria(projectSearchAction.oldStyleSearchUpdate(savedSearch.getXmlCriteria()));
					
			// resolve smart names
			savedSearch.setXmlCriteria(replaceSmartNames(savedSearch.getXmlCriteria(), LoginMgr.getLoginMgr(session), projectName));		
					
			luceneCriteria = projectSearchAction.getLuceneCriteria(savedSearch.getXmlCriteria());
			
			session.setAttribute(projectSearchAction.getCriteriaVariableName() + hpSectionId,
					savedSearch.getXmlCriteria());
		} else if (searchType == SearchConfiguration.SEARCHTYPE.TASKSEARCH) {
			pageName = projectID != null ? "projdetailswctasksearchresults" : "wctasksearchresults";
			searchFormat = "wctask";
			WcTaskSearchActionPage taskSearchAction = new WcTaskSearchActionPage(session, application, request,
					response);

			// Check for a session variable
			checkSessionVariable(session, savedSearch, taskSearchAction.getCriteriaVariableName() + hpSectionId, searchName);

			// required for old style saved searches.
			savedSearch.setXmlCriteria(taskSearchAction.oldStyleSearchUpdate(savedSearch.getXmlCriteria()));

			// resolve smart names
			savedSearch.setXmlCriteria(replaceSmartNames(savedSearch.getXmlCriteria(), LoginMgr.getLoginMgr(session), projectName));		

			extendedProjectUserCriteria = taskSearchAction.getExtendedProjectUserCriteria(savedSearch
					.getXmlCriteria());
			if (extendedProjectUserCriteria != null) {
				extendedProjectLuceneCriteria = taskSearchAction
						.generateExtendedProjectLuceneCriteria(extendedProjectUserCriteria);
			}
			updatedUserCriteria = taskSearchAction.getUserCriteria(savedSearch.getXmlCriteria());
			luceneCriteria = taskSearchAction.generateLuceneCriteria(updatedUserCriteria);
			session.setAttribute(taskSearchAction.getCriteriaVariableName() + hpSectionId,
					savedSearch.getXmlCriteria());
		} else {
			pageName = projectID != null ? "projdetailsdocsearchresults" : "docsearchresults";
			searchFormat = "generic";
			showGridBool = SearchDisplayMgr.isShowDocGrid(request, session);
			if (savedSearchType.equalsIgnoreCase("every_doc_type_search")) {
				searchFormat = "alldoc";
			} else if (savedSearchType.equalsIgnoreCase("graphic_doc_type_search")) {
				searchFormat = "graphic";
			} else {
				// Potential remote calls here if a re-cache is necessary. Probably not worth moving to app server.
				Vector docTypes = DocTypeCache.getInstance().getDBObjectsCache(response, session);
				for (int i = 0; i < docTypes.size(); i++) {
					DocType docType = (DocType) docTypes.elementAt(i);
					if (savedSearchType.equalsIgnoreCase(docType.getObjectID())) {
						searchFormat = docType.getAdvSearchJSP();
						// now we have to strip off search.jsp -- see SearchActionPage
						int index = searchFormat.indexOf("search.jsp");
						if (index != -1)
							searchFormat = searchFormat.substring(0, index);
						break;
					}
				}
			}
			DocSearchActionPage docSearchAction;
			if (searchFormat.equalsIgnoreCase("alldoc"))
				docSearchAction = new AllDocSearchActionPage(session, application, request, response);
			else if (searchFormat.equalsIgnoreCase("cape"))
				docSearchAction = new CapeDocSearchActionPage(session, application, request, response);
			else if (searchFormat.equalsIgnoreCase("collada"))
				docSearchAction = new ColladaDocSearchActionPage(session, application, request, response);
			else if (searchFormat.equalsIgnoreCase("des"))
				docSearchAction = new DesDocSearchActionPage(session, application, request, response);
			else if (searchFormat.equalsIgnoreCase("graphic"))
				docSearchAction = new GraphicDocSearchActionPage(session, application, request, response);
			else if (searchFormat.equalsIgnoreCase("graphicdf")) // ever used?
				docSearchAction = new GraphicDfDocSearchActionPage(session, application, request, response);
			else if (searchFormat.equalsIgnoreCase("graphicimage"))
				docSearchAction = new GraphicImageDocSearchActionPage(session, application, request, response);
			else if (searchFormat.equalsIgnoreCase("mfg"))
				docSearchAction = new MfgDocSearchActionPage(session, application, request, response);
			else if (searchFormat.equalsIgnoreCase("pagelist"))
				docSearchAction = new PagelistDocSearchActionPage(session, application, request, response);
			else
				// "generic", "3d"
				docSearchAction = new DocSearchActionPage(session, application, request, response, searchFormat);

			// Check for a session variable
			// Don't use it if we're running a saved search from a document upload search dialog. If we do we'll
			// end up running the same search regardless of which search link we've clicked. 
			if (!hpSectionId.equals("00001_9000000000")) {
				checkSessionVariable(session, savedSearch, docSearchAction.getCriteriaVariableName() + hpSectionId, searchName);
			}
			
			// required for old style saved searches.
			savedSearch.setXmlCriteria(docSearchAction.oldStyleSearchUpdate(savedSearch.getXmlCriteria()));

			// resolve smart names
			savedSearch.setXmlCriteria(replaceSmartNames(savedSearch.getXmlCriteria(), LoginMgr.getLoginMgr(session), projectName));		

			extendedProjectUserCriteria = docSearchAction.getExtendedProjectUserCriteria(savedSearch
					.getXmlCriteria());
			if (extendedProjectUserCriteria != null) {
				extendedProjectLuceneCriteria = docSearchAction
						.generateExtendedProjectLuceneCriteria(extendedProjectUserCriteria);
			}
			updatedUserCriteria = docSearchAction.getUserCriteria(savedSearch.getXmlCriteria());
			luceneCriteria = docSearchAction.generateLuceneCriteria(updatedUserCriteria);
			session.setAttribute(docSearchAction.getCriteriaVariableName() + hpSectionId,
					savedSearch.getXmlCriteria());
		}

		// Set up search criteria session variable. This will be needed if this search is re-run
		// using the saved search results with parameters screen. Not required for My Work page.
		if (hpSectionId.isEmpty())
			session.setAttribute(searchFormat + "SearchCriteria", savedSearch.getXmlCriteria());

		SearchConfiguration searchConfiguration = null;
		ExtendedSearchConfiguration extendedSearchConfiguration = null;
		ProjectSearchResultData projectSearchResultData = null;
		DocSearchResultData docSearchResultData = null;
		WcTaskSearchResultData wcTaskSearchResultData = null;
		
		if (debug) {
			LogMgr.getLogger().log(Level.WARNING, "XmlCriteria: " + savedSearch.getXmlCriteria());
			LogMgr.getLogger().log(Level.WARNING, "LuceneCriteria: " + luceneCriteria);
		}
		
		if (searchType == SearchConfiguration.SEARCHTYPE.PROJECTSEARCH) {
			// Get the current search configuration - total docs, start index, criteria, ...
			searchConfiguration = new SearchConfiguration(session, savedSearch.getXmlCriteria(),
					luceneCriteria, savedSearchType, showGridBool, searchType, isSavedSearchWithParms);

			// TODO: is this needed??? - it appears to just make a copy
			searchConfiguration = SearchDisplayMgr.transformSearchConfiguration(searchConfiguration, session,
					showGridBool, searchType);

			// There may be an optional override starting index (paging)
			searchConfiguration.setStartIndex(request);

			// DT-107983. Save search configuration in a session variable.
			// If not done here, "Save Search Results" won't work when search has been run from a custom menu.
			// Not required for My Work page.
			if (hpSectionId.isEmpty())
				session.setAttribute("luceneProjConfiguration", searchConfiguration);

			// Perform the search
			projectSearchResultData = SearchUtils.submitProjectSearch(session, request, response,
					searchConfiguration);
			if (projectSearchResultData == null || projectSearchResultData.getSearchResults() == null)
				return; // redirect already done; we can exit
		} else {
			// Get the current extended search configuration - total docs, start index, criteria, ...
			extendedSearchConfiguration = new ExtendedSearchConfiguration(session,
					savedSearch.getXmlCriteria(), updatedUserCriteria, extendedProjectUserCriteria,
					luceneCriteria, extendedProjectLuceneCriteria, savedSearch.getXmlCriteria(),
					savedSearchType, showGridBool, searchType, isSavedSearchWithParms);

			// TODO: is this needed??? - it appears to just make a copy
			extendedSearchConfiguration = SearchDisplayMgr.transformExtendedSearchConfiguration(
					extendedSearchConfiguration, session, showGridBool, searchType);

			// There may be an optional override starting index (paging)
			extendedSearchConfiguration.setStartIndex(request);

			// DT-107983. Save search configuration in a session variable.
			// If not done here, "Save Search Results" won't work when search has been run from a custom menu.   
			// Not required for My Work page.
			if (hpSectionId.isEmpty()) {
				if (searchType == SearchConfiguration.SEARCHTYPE.DOCUMENTSEARCH)
					session.setAttribute("luceneDocConfiguration", extendedSearchConfiguration);
				else
					session.setAttribute("luceneWctaskConfiguration", extendedSearchConfiguration);
			}

			// Perform the search
			if (searchType == SearchConfiguration.SEARCHTYPE.DOCUMENTSEARCH) {
				docSearchResultData = SearchUtils.submitDocSearch(session, request, response,
						extendedSearchConfiguration);
				if (docSearchResultData == null || docSearchResultData.getSearchResults() == null)
					return; // redirect already done; we can exit
			} else {
				wcTaskSearchResultData = SearchUtils.submitTaskSearch(session, request, response,
						extendedSearchConfiguration);
				if (wcTaskSearchResultData == null || wcTaskSearchResultData.getSearchResults() == null)
					return; // redirect already done; we can exit			
			}
		}

		// Common
		String resultIdListXml = "";
		if (searchType == SearchConfiguration.SEARCHTYPE.PROJECTSEARCH) {
			// Add thumbnails to search results
			SearchUtils.addThumbnailsToProjectSearchResultData(session, projectSearchResultData);

			// Generate a mapping from search result order to project id
			resultIdListXml = SearchUtils.getResultIdListInXml(projectSearchResultData.getSearchResults()
					.getResults());
		} else if (searchType == SearchConfiguration.SEARCHTYPE.DOCUMENTSEARCH) {
			// A couple of tasks to perform on the results.
			DocSearchUtils.postSearchProcessing(session, response, extendedSearchConfiguration,
					docSearchResultData, isShowThumbnails);

			// Generate a mapping from search result order to project id
			try {
				resultIdListXml = SearchUtils.getResultIdListInXml(docSearchResultData.getSearchResults()
						.getResults());
			} catch (InvalidParameterException ipEx) {
				JSPUtils.processInvalidParameterException(response, session, ipEx,
						"SearchUtils.getResultIdListInXml");
				return;
			}
		} else if (searchType == SearchConfiguration.SEARCHTYPE.TASKSEARCH) {
			// no add-ons for task search
		}

		// generate the xml for the page
		JSPDocXMLWriter xmlWriter;
		if (projDetailsPageHelper != null) {
			xmlWriter = projDetailsPageHelper.getJSPDocXMLWriter();
			if (!projDetailsPageHelper.startXml())
			   return;
		}
		else {
			xmlWriter = new JSPDocXMLWriter(application, session);			
			xmlWriter.writeXmlHeader("Search Results");
			
			// add home page section id if defined
			xmlWriter.writeSectionID(request.getParameter("sectionID"));
			// add simplified home page section flag if defined
			if (request.getParameter("showSimpleGUI") != null) {
				xmlWriter.writeSectionSimplifiedGUI(request.getParameter("showSimpleGUI"));
			}

			// language strings
			xmlWriter.writeXmlLanguageStrings(session);

			xmlWriter.writeXmlHelp(pageName);
			xmlWriter.writeXmlUser(response, session);
			// Potential remote calls here if a re-cache is necessary. Probably not worth moving to app server.
			xmlWriter.writeXmlApprovalLevelsForSearch(session, response);
			xmlWriter.writeXmlDocTypeList(session, response);

			String modMenu = SearchUtils.getSearchResultsModXML(session);
			String actionMenu = request.getParameter("actionMenu");
			if (actionMenu != null) {
				if (modMenu == null)
					modMenu = "";
				modMenu += "<menu5 menuitemname=\"" + XMLUtils.encodeXml(actionMenu) + "\"/>";
			}
//			xmlWriter.writeXmlStandardMenu(menuFile != null ? menuFile : pageName, modMenu, session);
			xmlWriter.writeXmlStandardMenu(pageName, modMenu, session);
		}

		// Add info whether search results are displayed on a page or in a dialog
		// This is needed for deciding whether to include certain javascript in 
		// the search results dialog used in document upload.
		if (StringUtils.checkForValue(request.getParameter("isInDialog"))) {
			xmlWriter.writeXmlString(Xml.getFieldXml("is_in_dialog", request.getParameter("isInDialog")));
		}
		
		if (searchType == SearchConfiguration.SEARCHTYPE.PROJECTSEARCH) {
			// Write out the search results and configuration - projects
			if (projectSearchResultData.getSearchResults().getNumHits() > 0) {
				try {
					ProjectViewListXml projectViewListXml = new ProjectViewListXml();
					projectViewListXml.getInXml(projectSearchResultData.getProjectViewList(),
							xmlWriter.getXmlWriterStream());
				} catch (XmlException xmlEx) {
					JSPUtils.processXMLException(response, session, xmlEx, "projectViewListXml.getInXml");
					return;
				}
			}
		} else if (searchType == SearchConfiguration.SEARCHTYPE.DOCUMENTSEARCH) {
			// Write out the search results and configuration - documents
			if (docSearchResultData.getSearchResults().getNumHits() > 0) {
				try {
					StringBuffer xmlDocBuffer = new StringBuffer();
					DocSearchResultListXml docSearchResultListXml = new DocSearchResultListXml();
					DocVerSearchResultListXml docVerSearchResultListXml = new DocVerSearchResultListXml();
					xmlDocBuffer.append(docSearchResultListXml.getInXml(docSearchResultData
							.getDocSearchResultList()));
					xmlDocBuffer.append(docVerSearchResultListXml.getInXml(docSearchResultData
							.getDocVerSearchResultList()));
					xmlWriter.writeXmlString(xmlDocBuffer.toString());
				} catch (XmlException xmlEx) {
					JSPUtils.processXMLException(response, session, xmlEx, "DocSearchResultListXml.getInXml");
					return;
				} catch (InvalidParameterException ipEx) {
					JSPUtils.processInvalidParameterException(response, session, ipEx,
							"DocSearchResultListXml.getInXml");
					return;
				}
			}
		} else {
			// Write out the search results and configuration - tasks
			if (wcTaskSearchResultData.getSearchResults().getNumHits() > 0) {
				try {
					ProjectWcTaskViewXml taskXml = new ProjectWcTaskViewXml();
					xmlWriter.writeXmlString("<wc_task_list>");
					// The search results are returned by strength... maintain that ordering
					// Normally we would add the search list of Ids to the xml as an index, like projsearchresults.jsp, however,
					// we are using the DisplayToDoListDetails template in projwctasktemplate.xsl which is also used for mytodolist.
					// This templates just renders the lists of tasks as it sees them, so just list the tasks in order of the search strength
					// when creating the XML to be transformed and be sure to omit tasks that may be in the index but may have been
					// deleted behind the scenes.
					for (String taskId : wcTaskSearchResultData.getSearchResults().getResults()) {
						ProjectWcTaskView tv = wcTaskSearchResultData.getTasksInfo().get(taskId);
						if (null != tv) {
							tv.setTaskStatus(wcTaskSearchResultData.getStatusInfo().get(tv.getStatusID()));
							xmlWriter.writeXmlString(taskXml.dumpFieldsInXml(tv));
						}
					}
					xmlWriter.writeXmlString("</wc_task_list>");
				} catch (XmlException xmlEx) {
					JSPUtils.processXMLException(response, session, xmlEx,
							"ProjectWcTaskViewXml.getInXml or SearchUtils.getResultIdListInXml");
					return;
				}

				// Write out the task documents
				ProjectWcTaskDocVersionViewXml projectWcTaskDocVersionViewXml = new ProjectWcTaskDocVersionViewXml();
				if (!wcTaskSearchResultData.getAllTaskDocuments().isEmpty()) {
					xmlWriter.writeXmlString("<project_wctask_doc_version_list>");
					for (Vector<ProjectWcTaskDocVersionView> taskDocuments : wcTaskSearchResultData
							.getAllTaskDocuments()) {
						for (ProjectWcTaskDocVersionView projectWcTaskDocVersionView : taskDocuments) {
							xmlWriter.writeXmlString(projectWcTaskDocVersionViewXml
									.getInSimpleXmlForSearchResults(projectWcTaskDocVersionView));
						}
					}
					xmlWriter.writeXmlString("</project_wctask_doc_version_list>");
				}

				// Write out Task Type Xml
				WcTaskSearchUtils.writeTaskTypeXml(xmlWriter, wcTaskSearchResultData.getTaskTypeList());

				// Write task status Xml
				WcTaskSearchUtils
						.writeTaskStatusXml(session, xmlWriter, wcTaskSearchResultData.getStatusInfo());
			}
		}

		xmlWriter.writeXmlString(resultIdListXml);

		if (searchType == SearchConfiguration.SEARCHTYPE.PROJECTSEARCH) {
			xmlWriter.writeXmlString(AttrSearchUtils.getRestrictedSetXMLFromRSetList(projectSearchResultData
					.getRestrictedSetList()));
			xmlWriter.writeXmlString(searchConfiguration.getConfigurationInXml());
			xmlWriter.writeXmlString(searchConfiguration.getUserCriteria());
			SearchUtils.processCheckForNoSearchResults(session, response, xmlWriter, projectSearchResultData
					.getSearchResults().getNumHits(), searchConfiguration.getSavedSearchType());
			xmlWriter.writeXmlString("<start_search_id>"
					+ projectSearchResultData.getSearchResults().getStartDoc() + "</start_search_id>");
			xmlWriter.writeXmlString("<result_count>" + projectSearchResultData.getSearchResults().getNumHits()
					+ "</result_count>");
		} else {
			xmlWriter.writeXmlString(extendedSearchConfiguration.getConfigurationInXml());
			xmlWriter.writeXmlString(extendedSearchConfiguration.getFullUserCriteria());

			if (searchType == SearchConfiguration.SEARCHTYPE.DOCUMENTSEARCH) {
				xmlWriter.writeXmlString(AttrSearchUtils.getRestrictedSetXMLFromRSetList(docSearchResultData
						.getRestrictedSetList()));
				SearchUtils.processCheckForNoSearchResults(session, response, xmlWriter, docSearchResultData
						.getSearchResults().getNumHits(), extendedSearchConfiguration.getSavedSearchType());
				xmlWriter.writeXmlString("<start_search_id>"
						+ docSearchResultData.getSearchResults().getStartDoc() + "</start_search_id>");
				xmlWriter.writeXmlString("<result_count>" + docSearchResultData.getSearchResults().getNumHits()
						+ "</result_count>");
			} else {
				xmlWriter.writeXmlString(AttrSearchUtils.getRestrictedSetXMLFromRSetList(wcTaskSearchResultData
						.getRestrictedSetList()));
				SearchUtils.processCheckForNoSearchResults(session, response, xmlWriter, wcTaskSearchResultData
						.getSearchResults().getNumHits(), extendedSearchConfiguration.getSavedSearchType());
				xmlWriter.writeXmlString("<start_search_id>"
						+ wcTaskSearchResultData.getSearchResults().getStartDoc() + "</start_search_id>");
				xmlWriter.writeXmlString("<result_count>"
						+ wcTaskSearchResultData.getSearchResults().getNumHits() + "</result_count>");
			}
		}

		// Common
		xmlWriter.writeXmlString("<saved_search_name>"
				+ XMLUtils.encodeXml(URLEncoder.encode(searchName, "utf-8")) + "</saved_search_name>");
		xmlWriter.writeXmlString("<search_scope>" + savedSearch.getScopeType() + "</search_scope>"); 
		xmlWriter.writeXmlString("<saved_search_name_title>" + XMLUtils.encodeXml(searchName)
				+ "</saved_search_name_title>");
		String showThumbnail = isShowThumbnails ? "1" : "0";
		xmlWriter.writeXmlString("<show_thumbnails>" + showThumbnail + "</show_thumbnails>");
		String showGrid = (showGridBool == true) ? "1" : "0";
		xmlWriter.writeXmlString("<show_grid>" + showGrid + "</show_grid>");

		if (searchReRun)
			xmlWriter.writeXmlString("<search_re_run>1</search_re_run>");

		// show the keyword search
		xmlWriter.writeXmlKeywordSearchInfo(session, response);

		// write project statuses into xml 
		// Potential remote calls here if a re-cache is necessary. Probably not worth moving to app server.
		xmlWriter.writeXmlAllProjectStatusesList(session, response);

		// write the action name in the XML
		if (actionName != null && actionName.length() > 0) {
			xmlWriter.writeXmlString("<saved_search_action>" + XMLUtils.encodeXml(actionName)
					+ "</saved_search_action>");
		}

		// footer
		xmlWriter.writeXmlFooter();
		//xmlWriter.dumpXMLToFile("C:\\Temp\\TempXML.xml");

		// perform the transformation
		xmlWriter.transformPage(pageName, out);
	} catch (Exception e) {
		JSPUtils.processGenericException(response, session, e, "dosavedsearch");
		return;
	}
%>

<%!
	/**
	* Replace all sub-strings in criteria that match <pattern> with (XML encoded) "value"
	*/
	public static String replaceSmartName(String criteria, String pattern, String value) {
//		return criteria.replaceAll("value=\"&lt;"+pattern+"&gt;\"","value=\"&quot;" + XMLUtils.encodeXml(value) + "&quot;\""); 					
		// we allow the string to be everywhere in the criteria; this is not risk free, but needed to simply resolve also more complex criterias 	
		return criteria.replaceAll("&lt;"+pattern+"&gt;","&quot;" + XMLUtils.encodeXml(value) + "&quot;").
				replaceAll("&lt;"+pattern.toLowerCase()+"&gt;","&quot;" + XMLUtils.encodeXml(value) + "&quot;"); // also allow the all-lowercase version 					
	}

	/**
	* Replace smart-name patterns in search criteria
	* Supported smart-names
	* <ProjectName> --> "Name of Project"
	* <UserLogin> --> "User Login Name"
	* <UserCompany> --> "User Company"
	* <UserLocation> --> "User Location"
	*/
	public static String replaceSmartNames(String luceneCriteria, LoginMgr loginMgr, String projectName) {

		// Note: currently only a complete criteria is matched, but while safer, that could be rather limiting (and not really in line with typical use of smart names) 
		
		if (projectName != null) {
			luceneCriteria=replaceSmartName(luceneCriteria, "ProjectName", projectName); 					
		}
		String userLogin = loginMgr.getUserName();
		String userCompany = loginMgr.getCompanyName() != null ? loginMgr.getCompanyName() : "";
		String userLocation = loginMgr.getLocationName() != null ? loginMgr.getLocationName() : "";
		luceneCriteria=replaceSmartName(luceneCriteria, "UserLogin", userLogin); 					
		luceneCriteria=replaceSmartName(luceneCriteria, "UserCompany", userCompany); 					
		luceneCriteria=replaceSmartName(luceneCriteria, "UserLocation", userLocation); 					
		// other possible smart-names:
		// userRoles - if multiple: ("Role1" OR "Role2" OR "Role3")
		// projectCustomer
		// projectAttributeXX - this one would allow to match on same value of a given attribute
		// project manager location, company, short code
		// project due-date (e.g. show tasks estimated to be late)
		// sales person
		// - for some/all of these, we should first check if they were used before loading the actual data
		return luceneCriteria;
	}  
%>

<%!
	/**
	* Check if there's a cached search with the same seaved search name
	*/
	public static void checkSessionVariable(HttpSession session, SavedSearch savedSearch, String key, String ssName) {
		String searchSessionVariable = (String)session.getAttribute(key);
		if (searchSessionVariable != null) {
			// okay, there is a session variable. Now we need to check if we have the same saved search name, otherwise, we cannot use it.
			String lastUsedSavedSearchName = (String)session.getAttribute(key + "_ssname");
			if(StringUtils.checkForValue(lastUsedSavedSearchName) && lastUsedSavedSearchName.equals(ssName)){
				savedSearch.setXmlCriteria(searchSessionVariable);	
			}
		}
		// set last saved search name
		session.setAttribute(key + "_ssname", ssName);
	}
%>
